Description

This is a simple guide for setting up and using Linux Containers on Arch Linux.

Prepare the Environment

o Make sure the system is up to date:
pacman —-Syu

e |nstall the base-devel and wget packages:
pacman —-S base-devel wget rsync

e |nstall yaourt

Set Up The Network

¢ |nstall netctl:

pacman —-S netctl

Bridged Wired Connection

e Bridge Internet-shared - This example will bridge network interface eth0 and configure a static IP for the bridge:

nano /etc/netctl/lxcbridge

o And add/modify the following:

Description="LXC Bridge"
Interface=br0
Connection=bridge
BindsToInterfaces=(eth0)
IP=static
Address=192.168.1.100/24
Gateway=192.168.1.1
DNS=192.168.1.1
SkipForwardingDelay=yes

e After changes are made, make sure to re-enable and restart the bridge:

netctl enable lxcbridge
netctl start lxcbridge

e Enable IP Forwarding persist at boot:

echo 'net.ipv4.ip_forward=1l' >> /etc/sysctl.d/40-ip-forward.conf

e And also apply this iptables rule:

iptables -t nat —-A POSTROUTING -o eth0 -3j MASQUERADE

o To make changes persist upon reboot:

iptables-save > /etc/iptables/iptables.rules
systemctl enable iptables
systemctl start iptables

NAT Wireless Connection

* Make sure that forwarding is turned on to support NAT:

echo 1 > /proc/sys/net/ipv4/ip_forward

e Make the previous change persistent after a reboot:

echo 'net.ipv4d.ip_forward=1' >> /etc/sysctl.d/30-ipforward.conf
echo 'net.ipvé6.conf.default.forwarding=1' >> /etc/sysctl.d/30-ipforward.conf
echo 'net.ipvé.conf.all.forwarding=1' >> /etc/sysctl.d/30-ipforward.conf

Now create the bridge:

o NAT Internet-shared - This example will bridge network interface eth0 and configure a static IP for the bridge:

nano /etc/netctl/lxcnatbridge
o And add/modify the following:

Description="LXC NAT Bridge"
Interface=natbr0
Connection=bridge
IP=static
Address=192.168.10.200/24
DNS=192.168.1.1

SkipForwardingDelay=yes
ExecUpPost="/usr/local/bin/natbr0-up"

Create the nat script:

nano /usr/local/bin/natbr0-up

* And add the following:

#!/bin/sh

04/19/2024 2/8




# Script to setup NAT iptables masquerade rules; and dnsmasq for DHCP and DNS.

# This is the address assigned to the bridge at boot
BRADDR=192.168.10.200

# DHCP IP address range for containers
BRRANGE=192.168.10.201,192.168.10.250

# Configure iptables rules for NAT

iptables —-A FORWARD -i natbr0 -s ${BRADDR}/24 -m conntrack --ctstate NEW -3j ACCEPT
iptables —-A FORWARD -m conntrack —--ctstate ESTABLISHED,RELATED -j ACCEPT

iptables —-A POSTROUTING -t nat -3j MASQUERADE

# Start dnsmasqg DNS/DHCP server for the network attached to the NAT interface.
dnsmasqg --bind-interfaces —--conf-file= --listen-address S$BRADDR --except-interface lo —--dhcp-r
ange $BRRANGE --dhcp-lease-max=253 —--dhcp-no-override

® Make sure it is executable by doing

chmod +x /usr/local/bin/natbr0O-up

e Start and enable the NAT bridge at boot:

netctl enable lxcnatbridge
netctl start lxcnatbridge

e Now a container Ixc.conf should read:

lxc.network.type=veth
lxc.network.link=natbr0
lxc.network.flags=up

Install LXC

e [nstall Ixc, bridge-utils, and arch-install-scripts:

pacman —-S bridge-utils arch-install-scripts dnsmasqg

o (Optional) Install extra packages for Ixc:

pacman -S lua lua-filesystem lua-alt-getopt

® Install debootstrap from AUR:

yaourt debootstrap

o Install gnupg1 for keyring verification; make sure to edit the PKGBUILD and add armv7h to the arch parameter:

yaourt gnupgl

o Install debian-archive-keyring:

yaourt debian-archive-keyring
o Install ubuntu-keyring:
yaourt ubuntu-keyring
e Test that the system is correctly configured

l1xc-checkconfig

o The output should be similar to:

——— Namespaces ——-—

Namespaces: enabled

Utsname namespace: enabled

Ipc namespace: enabled

Pid namespace: enabled

User namespace: missing

Network namespace: enabled

Multiple /dev/pts instances: enabled

——— Control groups ——-—

Cgroup: enabled

Cgroup clone_children flag: enabled
Cgroup device: enabled

Cgroup sched: enabled

Cgroup cpu account: enabled

Cgroup memory controller: enabled
Cgroup cpuset: enabled

—-—— Misc —-——

Veth pair device: enabled
Macvlan: enabled

Vlan: enabled

File capabilities: enabled

Container setup

To find all available templates that come with LXC, look in /usr/share/Ixc/templates directory:

1ls /usr/share/lxc/templates

e Example output:

lxc-alpine 1xc-altlinux 1Ixc-archlinux 1lxc-busybox 1lxc-centos
download 1lxc-fedora 1xc-gentoo 1lxc-openmandriva lxc-opensuse
shd 1lxc-ubuntu 1lxc-ubuntu-cloud

Arch Container

e Create the container:

lxc—-create -n arch.example.com -t archlinux

e Edit the Arch Linux container config file:

nano /var/lib/lxc/arch.example.com/config

04/19/2024

lxc-cirros
lxc-oracle

lxc—-debian
lxc-plamo

4/8

1xc—
1xc-s




o And add/modify the following:

lxc.network.type = veth
lxc.network.flags = up
1xc.network.link = br0
#1lxc.network.hwaddr =

lxc.network.ipvd = 192.168.1.101
lxc.network.ipvéd.gateway = 192.168.1.1
lxc.network.name = ethO

lxc.autodev =1

1lxc.pts = 1024

1lxc.kmsg = 0

lxc.rootfs = /var/lib/lxc/arch.example.com/rootfs
lxc.utsname = arch.example.com
lxc.arch = armv71

e Start the Arch container:

lxc-start -n arch.example.com

e Open a console:

lxc—-attach —-n arch.example.com

o And change the password:

passwd

e Create a wired connection:

cp /etc/netctl/examples/ethernet-static /etc/netctl/wired

e Edit the /etc/netctl/wired to match your needs.

nano /etc/netctl/wired

o Add/modify the following:

Description='Ethernet Connection'
Interface=eth0
Connection=ethernet

IP=static
Address=('192.168.1.101/24")
Gateway=('192.168.1.1")
DNS=('192.168.1.1")

# Required to start a network connection in a container
ForceConnection=yes

e Start and enable the wired connection at boot:

netctl enable wired
e NOTE: | needed to edit /etc/systemd/system/netct\@wired.service and comment out the following in order for the netctl
command to start:

#BindsTo=sys-subsystem-net-devices-ethO.device
#After=sys—-subsystem-net-devices-eth0.device
o Then reload the systemd units:
systemctl daemon-reload

* While the console to the container is open, install openssh

pacman —S openssh

o Start and enable openssh at boot:

systemctl enable sshd.service
systemctl start sshd.service

Raspbian Container

e Copy the existing Debian LXC template:

cp /usr/share/lxc/templates/lxc-debian /usr/share/lxc/templates/lxc-raspbian

¢ Edit the Raspbian LXC template:

nano /usr/share/lxc/templates/lxc-raspbian

o And modify the following parameters:

MIRROR=S${MIRROR:-http://archive.raspbian.org/raspbian}

#...
arch="armhf'
debootstrap —--verbose --variant=minbase --arch=$arch --no-check-gpg

o NOTE: The MIRROR variable is set to Rasbian repositories at http:/archive.raspbian.org/raspbian
o NOTE: The arch variable is set to armhf
o NOTE: The debootstrap command has the added --no-check-gpg argument

e Create the container:

lxc-create -n raspbian.example.com -t raspbian

o Edit the Raspbian container config file:

nano /var/lib/lxc/raspbian.example.com/config

o And add/modify the following:

1lxc.network.type = veth
lxc.network.flags = up
lxc.network.link = natbr0
lxc.network.name = ethO

lxc.rootfs = /var/lib/lxc/raspbian.example.com/rootfs
lxc.utsname = raspbian.example.com

lxc.arch = armvhf

e Start the containter:

lxc-start -n raspbian.example.com

* Configure the container to use systemd within Ixc:

lxc.autodev = 1

lxc.pts = 1024

lxc.kmsg = 0
1xc.hook.autodev=/var/lib/lxc/raspbian.example.com/autodev

Autostart Containers

e Autostart the Arch container:

systemctl enable lxc@arch.example.com.service

e Autostart the Raspbian container:

systemctl enable lxc@raspbian.example.com.service

Resources

e https://s3hh.wordpress.com/2011/05/17/Ixc-containers-on-a-host-with-wireless/
e https://wiki.archlinux.org/index.php?titie=Linux_Containers&redirect=no

History

#1 - 03/01/2015 01:03 PM - Daniel Curtis
- % Done changed from 10 to 30
- Description updated

- Status changed from New to In Progress

#2 - 03/01/2015 05:34 PM - Daniel Curtis

- Description updated

#3 - 03/01/2015 06:34 PM - Daniel Curtis

- Description updated

#4 - 03/01/2015 06:39 PM - Daniel Curtis
- Description updated

- % Done changed from 30 to 50

#5 - 03/01/2015 07:20 PM - Daniel Curtis

- Description updated

#6 - 03/02/2015 02:57 PM - Daniel Curtis

- Description updated

04/19/2024

7/8



https://s3hh.wordpress.com/2011/05/17/lxc-containers-on-a-host-with-wireless/
https://wiki.archlinux.org/index.php?title=Linux_Containers&redirect=no

#7 - 04/14/2015 02:53 PM - Daniel Curtis
- Description updated

#8 - 05/05/2015 12:49 PM - Daniel Curtis
- Description updated
- % Done changed from 50 to 70

#9 - 05/05/2015 01:01 PM - Daniel Curtis

- Description updated

#10 - 05/05/2015 01:13 PM - Daniel Curtis

- Description updated

#11 - 05/05/2015 04:38 PM - Daniel Curtis

- Description updated

#12 - 11/15/2015 02:46 PM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 70 to 100

#13 - 11/27/2015 04:47 PM - Daniel Curtis

- Status changed from Resolved to Closed

#14 - 07/15/2016 07:42 PM - Daniel Curtis

- Description updated

04/19/2024

8/8


http://www.tcpdf.org

